Forum:Lisp
Thema:LISP-Befehl bei Errormeldung abbrechen
Möchten Sie sich registrieren?
Wer darf antworten? Registrierte Benutzer können Beiträge verfassen.
Hinweise zur Registrierung Sie müssen registriert sein, um Beiträge oder Antworten auf Beiträge schreiben zu können.
Ihr Benutzername:
Ihr Kennwort:   Kennwort vergessen?
Anhang:    Datei(en) anhängen  <?>   Anhänge verwalten  <?>
Grafik für den Beitrag:                                                
                                                       
Ihre Antwort:

Fachbegriff
URL
Email
Fett
Kursiv
Durchgestr.
Liste
*
Bild
Zitat
Code

*HTML ist AUS
*UBB-Code ist AN
Smilies Legende
Netiquette

10 20 40

Optionen Smilies in diesem Beitrag deaktivieren.
Signatur anfügen: die Sie bei den Voreinstellungen angegeben haben.

Wenn Sie bereits registriert sind, aber Ihr Kennwort vergessen haben, klicken Sie bitte hier.

Bitte drücken Sie nicht mehrfach auf "Antwort speichern".

*Ist HTML- und/oder UBB-Code aktiviert, dann können Sie HTML und/oder UBB Code in Ihrem Beitrag verwenden.

T H E M A     A N S E H E N
Stefan-Schirge

Beiträge: 42 / 0

Hallo,

ich habe ein kleines Problem mit meiner LISP. Und zwar möchte ich, dass er bei einer Fehlermeldung die LISP komplett beendet.
Leider klappt dies nicht und er will immer wieder den nächsten befehl ausführen. Kann jemand helfen?

(defun c:BP4test ( / myerror plot_func zip_func ende_func)
;-------------------------------------------------------
;-------------Plotfunktion------------------------------
;-------------------------------------------------------
(defun plot_func ( / )
(setq *ERROR* myerror)
(setvar "ctab" "PDF")
(command-s "_.PSPACE")
(command "zoom" "g")
(command "plot" "nein" "PDF" "" ""
  (strcat (getvar 'dwgprefix)
                (vl-filename-base (getvar 'dwgname))
                ".pdf"
  )
  "" ""
)
)


;-------------------------------------------------------
;-------------E-Transmit--------------------------------
;-------------------------------------------------------
(defun zip_func ( / )
  (setvar "ctab" "Modell")
  (command "zoom" "g")
  (command "bereinig" "AL" "" "N")
  (bns_redir  "*" ".")
  (if (ssget "X" '((0 . "IMAGE"))) (command "isave"))
  (command-s "_.qsave"
        "_.-etransmit"
        "_c"
        (strcat (getvar 'dwgprefix)
                (vl-filename-base (getvar 'dwgname))
                ".zip"
        )
  )

)

;-------------------------------------------------------
;-------------Endebefehl--------------------------------
;-------------------------------------------------------

(defun ende_func ( / )
(exit)

 
 
;-------------------------------------------------------
;-------------Errorhandling-----------------------------
;-------------------------------------------------------

  (defun myerror (msg / )
  (alert "Bitte PDF schließen und den Befehl erneut starten.") 
  (command-s "._UNDO" "1")
  (ende_func)
  (setq *ERROR* nil)
 
  )

;-------------------------------------------------------
;-------------Programmablauf----------------------------
;-------------------------------------------------------

  (plot_func)
  (zip_func)
(princ)
);End of Function


------------------
AutoCad 2018

Bernhard GSD

Beiträge: 481 / 0

AutoCAD 2020(Deu); Windows 10 PRO x64(Deu)

(defun c:BP4test ( / *error* myerror plot_func zip_func ende_func)

myerror schützen macht die die externe Defintion unwerksam.
Aber *error* muss geschützt sein.

Ich definiere *error* innerhalb der Befehlsdefinition und schütze auch alle Systemvariablen, die *error* zurück setzen soll (was hier nicht der Fall ist)

------------------
Gruß aus Wien
Bernhard

Andreas Kraus

Beiträge: 1328 / 4

WIN 10
ACAD 2022

Eben erst gesehen  und gleich Feierabend  .
Das hier schon durchgearbeitet ?

http://advanced.autolisp.info/error1.html
http://advanced.autolisp.info/error2.html

------------------
Geht nicht, gibts nicht

Gruß
Andreas

http://kraus-cad.de